'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.pool = undefined;

var _toArray2 = require('babel-runtime/helpers/toArray');

var _toArray3 = _interopRequireDefault(_toArray2);

var _symbol = require('babel-runtime/core-js/symbol');

var _symbol2 = _interopRequireDefault(_symbol);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _tool = require('../common/tool');

var _tool2 = _interopRequireDefault(_tool);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * 仅限于池方式调用的方法
 * @author(baibing)
 * @param('size','')
 * @param(func:创建对象的方法)
 * @param(waitTime,过期时间)
 */
var pool = exports.pool = function () {
    function pool() {
        var size = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 10;
        var func = arguments[1];
        var waitTime = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 10;
        (0, _classCallCheck3.default)(this, pool);

        var that = this;

        var _pri = pri(that, {
            size: size,
            func: func,
            waitTime: waitTime,
            data: [],
            have: [],
            wait: [],
            use: {},
            KEY: (0, _symbol2.default)('_____poolid'),
            addUse: function addUse(v) {
                var _pri2 = pri(that),
                    _ = _pri2._,
                    __ = _pri2.__;

                if (v) {
                    if (!_tool2.default.isValid(v[__.KEY])) {
                        v[__.KEY] = _tool2.default.random();
                    }
                    __.use[v[__.KEY]] = v;
                }
            },
            delUse: function delUse(v) {
                var _pri3 = pri(that),
                    _ = _pri3._,
                    __ = _pri3.__;

                if (v) {
                    if (_tool2.default.isValid(v[__.KEY]) && _tool2.default.isValid(__.use[v[__.KEY]])) {
                        delete __.use[v[__.KEY]];
                    }
                }
            }
        }),
            _ = _pri._,
            __ = _pri.__;

        __.clear = new clearer(_, __);
        __.clear.start();
    }

    (0, _createClass3.default)(pool, [{
        key: 'getValue',
        value: function getValue() {
            var _pri4 = pri(this),
                _ = _pri4._,
                __ = _pri4.__;

            return _tool2.default.callback(function (call) {
                var v = __.have.pop();
                if (v) {
                    v = v.value;
                    __.addUse(v);
                    call(null, v);
                } else if (__.data.length < __.size) {
                    _tool2.default.callback2(__.func, __).then(function (v) {
                        __.addUse(v);
                        __.data.push(v);
                        call(null, v);
                    });
                } else {
                    __.wait.push({ endDate: new Date().add('s', __.waitTime), value: call, dispose: call });
                }
            });
        }
    }, {
        key: 'setValue',
        value: function setValue(v) {
            var _pri5 = pri(this),
                _ = _pri5._,
                __ = _pri5.__;

            __.delUse(v);
            if (_tool2.default.isValid(v) && _tool2.default.isValid(v[__.KEY])) {
                if (__.wait.length > 0) //仅针对getValue异步操作有效
                    _tool2.default.once(function () {
                        __.addUse(v);
                        __.wait.shift().value(null, v);
                    });else __.have.push({ endDate: new Date().add('s', __.waitTime), value: v, dispose: function dispose() {
                        if (v.dispose) v.dispose();
                    } });
            }
        }
    }, {
        key: 'dispose',
        value: function dispose() {
            var _pri6 = pri(this),
                _ = _pri6._,
                __ = _pri6.__;

            __.clear.stop();
            while (__.have.length > 0) {
                var val = __.have.shift();
                if (val.dispose) {
                    _tool2.default.tryC(val.dispose);
                    val = null;
                }
            }
            __.data = __.data.splice(0);
        }
    }]);
    return pool;
}();
exports.default = { pool: pool };

var pri = _tool2.default.pris();

var clearer = function () {
    function clearer(obj, objpri) {
        (0, _classCallCheck3.default)(this, clearer);

        var _pri7 = pri(this, { obj: obj, pri: objpri }),
            _ = _pri7._,
            __ = _pri7.__;

        this.tid = null;
    }

    (0, _createClass3.default)(clearer, [{
        key: 'check',
        value: function check(datas) {
            var endDate = datas.length > 0 ? datas[0].endDate : null;
            if (_tool2.default.isValid(endDate) && new Date().diff('ms', endDate) > 0) {
                return false;
            } else {
                while (datas.length > 0) {
                    var val = datas.shift();
                    if (val.dispose) {
                        _tool2.default.tryC(val.dispose);
                        val = null;
                    }
                }
                return true;
            }
        }
    }, {
        key: 'start',
        value: function start() {
            var _pri8 = pri(this),
                _ = _pri8._,
                __ = _pri8.__;

            _.tid = global.setTimeout(function () {
                var ret = _.check(__.pri.data);
                if (ret) {
                    var _$pri$use = (0, _toArray3.default)(__.pri.use);

                    __.pri.data = _$pri$use;

                    _.start();
                }
                _.check(__.pri.wait);
            }, 500);
        }
    }, {
        key: 'stop',
        value: function stop() {
            var _ = this;
            if (_.tid) global.clearTimeout(_.tid);
            _.tid = null;
        }
    }]);
    return clearer;
}();

;
//# sourceMappingURL=pool.js.map